AEXAM:   ORG 00100H   ; LOADING ADDRESS
;
;  <<< PROGRAM TO DISPLAY THE ASCII OF MEMORY CONTENTS >>>
;***** WRITTEN BY DON VAN DYKE : DR. DOBBS JOURNAL # 21
;***** (VOL.3, ISSUE 3)
;
       XRA  A        ; INITIALIZE SCREEN
       OUT  0FEH     ; SET SOL
       OUT  0C8H     ; SET VDM
       LXI  B,OFFST  ; (-2048)
       LXI  D,0      ; BEGINNING OF MEMORY
NEXT:  CALL DISP     ; DISPLAY 1K
INL:   CALL SINP     ; GET CHARACTER FROM SOLOS/CUTER
       JZ   INL      ; READY ?
       ANI  7FH      ; STRIP PARITY
       CPI  1BH      ; ESCAPE KEY HIT ?
       JZ   RETRN    ; ...YES, RETURN TO SOLOS
       CPI  9        ; TAB OR CTRL-I ?
       JZ   TAB      ; ...YES
       CPI  17H      ; UP ARROW OR CTNL-W KEY ?
       JZ   NEXT     ; ...YES
       CPI  1AH      ; DOWN ARROW OR CTRL-Z ?
       JZ   BACK     ; ...YES
       JMP  INL      ; IF NONE OF THESE, THEN TRY ANOTHER CH.
;
; <*> ROUTINE TO SKIP 8K AND DISPLAY <*>
;
TAB:   XCHG
       LXI  D,2000H  ; 8K TO SKIP
       DAD  D        ; ADD THE OFFSET
       XCHG
       JMP  DISP     ; DISPLAY IT
;
BACK:  XCHG
       DAD  B        ; SUBTRACT 2K
       XCHG
;
DISP:   LXI  H,VDM   ; BEGINNING OF DISPLAY
AGAIN:  LDAX D       ; GET THE CHARACTER FROM MEMORY
       MOV  M,A      ; PUT IT ON THE SCREEN
       INX  D        ; NEXT MEMORY LOCATION
       INX  H        ; NEXT SCREEN LOCATION
       MOV  A,H      ; GET HIGH ORDER ADDRESS
       CPI  0D0H     ; END OF SCREEN ADDRESS ?
       JNZ  AGAIN    ; ...NO, DO IT AGAIN
       JMP  INL      ; GET ANOTHER CHARACTER
                     ; SYSTEM I/O ENTRY PORT (INPUT)
SINP   EQU  0C01FH
VDM    EQU  0CC00H
RETRN  EQU  0C004H
OFFST  EQU  0F800H
;*****
ENDIT:   END
