;
;  <*>  S O L   MEMORY  TEST   <*>  
;   
;   
;  <<<  EQUATES  >>>
;   
PRINT   EQU 0C08AH       ; <SOL> "PRINT CHAR."   ROUTINE
ADDRS   EQU 0C2D7H       ; <SOL> "PRINT ADDRESS" ROUTINE
DISPL   EQU 0C08AH       ; <SOL> "PRINT COUNT" ROUTINE  
SOLOS   EQU 0C004H       ; <SOL> MONITOR ENTRY  
PERSE   EQU 0C0D5H       ; <SOL> CLEAR SCREEN   
CLINE   EQU 0C0F4H       ; <SOL>
PSCAN   EQU 0C310H       ; <SOL>
SCONV   EQU 0C33AH       ; <SOL>
ADOUT   EQU 0C3E8H       ; <SOL>
BOUT    EQU 0C406H       ; <SOL>
HEOUT   EQU 0C40BH       ; <SOL>
OUTH    EQU 0C41FH       ; <SOL>
EXIT    EQU 0            ; RETURN TO CP/M   
CR      EQU     00DH     ; CARRIAGE RETURN  
LF      EQU     00AH     ; LINE FEED
VDADD   EQU     0C11CH   ; CHECK SCREEN POSITION
CRLF    EQU     0C2F9H   ; LINE FEED + CARRIAGE RETURN ROUTINE  
SOUT    EQU     0C019H   ; SYSTEMS OUTPUT ROUTINE (OPORT)   
SINP    EQU     0C01FH   ;  
NCHAR   EQU     0C808H   ; CURRENT CHARACTER POSITION   
;   
       ORG 0100H
;   
FIREUP:  XRA   A                      ; SET-UP <SOL>
         OUT   0FEH 
         OUT   0C8H 
         CALL  PERSE                  ; CLEAR SCREEN
         LXI   H,MSG1   
         CALL  MSG  
         CALL  CRLF 
         LXI   H,MSG2   
         CALL  MSG  
         CALL  CRLF 
         CALL  CRLF 
         LXI   H,MSG3   
         CALL  MSG  
         CALL  CRLF 
COOKS:   LXI   H,PASSES               ; NUMBER OF PASSES THROUGH TEST   
         MOV   C,M                    ; GET REPEAT COUNT
         LXI   H,START                ; START ADDRESS   
         SHLD  START                  ; SAVE IT 
         LXI   H,COUNT                ; # OF BYTES TO TEST  
         SHLD  COUNT                  ; SAVE IT 
LINE0: LXI SP,0C8FFH  ; LOCATE STACK
       LHLD  COUNT    ; LOAD COUNT  
       XCHG           ; SWAP
       LHLD  START    ; LOAD START ADDRESS  
LINE1: XRA   A        ; CLR "A" REG.
       MVI M,00       ; CLR TEST ADDRESS
       DCX D          ; COUNT BYTES 
       INX H          ; INCREASE ADDRESS
       CMP D          ; ...ALL LOADED ? 
       JNZ LINE1      ; ...IF NOT, DO NEXT ADDRESS  
       CMP E
       JNZ LINE1
       LHLD  COUNT    ; LOAD COUNT  
       XCHG           ; SWAP
       LHLD  START    ; LOAD START ADDRESS  
LINE2: XRA   A        ; CLR "A" 
       CMP M          ; LOCATION CLEAR ?
       CNZ PART2      ; FAILED? ...CALL 'PRINT A'   
       DCX D          ; COUNT BYTES 
       INX H          ; INCREASE ADDRESS
       CMP D          ; ...ALL LOADED?  
       JNZ LINE2      ; ...IF NOT, DO NEXT ADDRESS  
       CMP E
       JNZ LINE2
       LHLD  COUNT    ; LOAD COUNT  
       XCHG           ; SWAP
       LHLD  START    ; LOAD START ADDRESS  
LINE3: XRA   A        ; CLR "A" REG.
       CMP M          ; LOCATION CLEAR ?
       CNZ LINE5      ; FAILED? ...CALL 'PRINT B'   
       MVI A,01       ; LOAD '0000 0001' IN "A" REG.
LINE4: MOV M,A        ; MOVE TO TEST ADDRESS
       CMP M          ; LOAD O.K.?  
       CNZ LINE6      ; FAILED? ...CALL 'PRINT C'   
       RAL            ; ROTATE BIT LEFT 
       JNC LINE4      ; 8 BITS CHECKED ?
       MVI A,0FFH     ; LOAD '1111 1111' IN "A" REG.
       MOV M,A        ; MOVE TO TEST ADDRESS
       CMP M          ; LOAD O.K.?  
       CNZ LINE7      ; FAILED? ...CALL 'PRINT D'   
       DCX D          ; COUNT BYTES 
       INX H          ; INCREASE ADDRESS
       XRA   A        ; CLR "A" REG.
       CMP D          ; ...ALL LOADED ? 
       JNZ LINE3      ; ...IF NOT, DO NEXT ADDRESS  
       CMP E
       JNZ LINE3
       CALL  LINE9    ; CALL 'PRINT "BELL"' 
       DCR   C        ; COUNT REPEATS   
       XRA   A        ; CLEAR "A" REG.  
       CMP   C        ; ALL REPEATS DONE ?  
       JNZ   LINE0    ; IF NOT, DO IT AGAIN 
;   
       JMP   EXIT     ; EXIT TO SYSTEM RE-ENTRY POINT   
;   
PART2: MVI B,41H      ; LOAD 'A'
       JMP LINE8      ; PRINT IT
LINE5: MVI B,42H      ; LOAD 'B'
       JMP LINE8      ; PRINT IT
LINE6: MVI B,43H      ; LOAD 'C'
       JMP LINE8      ; PRINT IT
LINE7: MVI B,44H      ; LOAD 'D'
LINE8: PUSH  B        ; SAVE REPEAT COUNT   
       PUSH  H        ; SAVE ADDRESS
       CALL  PRINT    ; "PRINT" THE CHARACTER   
       POP   H        ; RESTORE ADDRESS 
       CALL  ADDRS    ; "PRINT" THE ADDRESS 
       POP   B        ; RESTORE REPEAT COUNT
       RET            ; GO BACK TO MM-III.  
;   
LINE9: PUSH H         ; SAVE ADDRESS
       MOV  H,B       ; SET-UP FOR PRINTING COUNT   
       MOV  L,C 
       PUSH B         ; SAVE REPEAT COUNT   
       MVI  B,07H     ; LOAD "BELL" SYMBOL  
       CALL PRINT     ; "PRINT" THE CHARACTER   
       CALL DISPL     ; "PRINT" THE REPEAT COUNT
       POP  B         ; RESTORE REPEAT COUNT
       POP  H         ; RESTORE ADDRESS 
       RET            ; GO BACK TO MM-III.  
;   
PASSES:  DB  0FFH ; NUMBER OF PASSES THROUGH THE TEST  
START:   DW  01000H                   ; START ADDRESS   
COUNT:   DW  09000H                   ; NUMBER OF BYTES TO TEST 
;   
;--------------------------------------------------------*  
;   
;       ::: MESSAGE OUTPUT ROUTINE :::  
;   
;       H+L HAVE MSG'S ADDRESS, "0" ENDS MESSAGE.   
;   
MSG:   MOV       A,M       ; GET A CHARACTER
       CPI        0        ; END-OF-MESSAGE ?   
       RZ                  ; ... YES, YOUR DONE 
       MOV       B,A
       CALL      SOUT      ; OUTPUT IT  
       INX       H         ; NEXT CHARACTER 
       JMP       MSG
;   
;---------------------------------------------------------* 
;   
MSG1:    DB    ' <*>  COOKS MEMORY TEST  <*>'   
         DB    0
MSG2:    DB    ' KILOBAUD: JULY 1978, PAGE 70.' 
         DB    0
MSG3:    DB    ' MEMORY TEST IS SET TO RUN 3 TIMES.'
         DB    0
;   
;---------------------------------------------------------* 
;   
;        ::: KEYBOARD INPUT ROUTINE ::: 
;   
;            "H+L" = START OF CHARACTER INPUT BUFFER.   
;            UP TO 80 CHARACTERS ARE PUT INTO A BUFFER. 
;            (DEL) KEY DECREMENTS BUFFER COUNT & REMOVES
;            THE CHARACTER.   BUFF=BUFFER FOR INPUT 
;            KCNT=BUFF COUNT   NBUF=NEXT BUFF ENTRY ADDRESS 
;   
; . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .   
;   
KEYIN:   SHLD   BUFF   ; SAVE START-OF-BUFFER FOR INPUT 
         SHLD   NBUF   ; FIRST ADDRESS TO GET A CHAR.   
KEYIN1:  CALL   SINP   ; GET SOME INPUT CHAR.   
         JZ     KEYIN1  
         ANI    07FH   ; STRIP ANY PARITY BITS  
         JZ     KEXIT  ; (MODE) KEY EXITS   
         MOV    B,A    ; SAVE CHAR. IN B
         CPI    CR     ; CARRIAGE RETURN?   
         JZ     KCHEK  ; ... YES, CHECK SCREEN POSITION 
         CPI    LF     ; LINE FEED? 
         RZ            ; ... YES, DONE  
         CPI    07FH   ; (DEL) KEY? 
         JNZ    KEY1   ; ... NO 
         MVI    B,05FH ; ... YES, BACKUP, REMOVE CHAR.  
         LXI    H,NBUF ; BACKUP NEXT BUFF. INPUT ADDRESS
         DCR    M   
         LXI    H,KCNT ; BACKUP THE COUNT   
         DCR    M   
         JMP    KEY2
;   
KEY1:    LHLD   NBUF   ; GET NEXT BUFF INPUT ADDRESS
         MOV    A,B    ; GET A CHARACTER
         MOV    M,A    ; SAVE INTO THE INPUT BUFFER 
         INX    H      ; INCREMENT ADDRESS POINTER  
         SHLD   NBUF   ; SAVE ADDRESS TO PUT NEXT CHAR. 
         LXI    H,KCNT ; GET "COUNT" POINTER
         INR    M      ; INCREMENT COUNT
         MOV    A,M    ; GET THE COUNT  
         CPI    80     ; 80TH CHARACTER?
         JZ     KEXIT  ; ... YES, EXIT  
         MOV    A,B    ; RESTORE CHAR.  
;   
KEY2:    CALL   SOUT   ; PUT OUT A CHARACTER
         JMP    KEYIN1  
;   
KCHEK:   CALL   VDADD ; GET CURRENT SCREEN ADDRESS  
         LDA    NCHAR ; CURRENT CURSOR POSITION 
KCHE1:   CPI    64    ; NO MORE THAN 63 
         JNC    KEXIT ; ... ALL DONE
         MVI    M,' ' ; SPACE OUT THE LINE  
         INX    H   
         INR    A   
         JMP    KCHE1   
;   
KEXIT:   MVI    A,CR  ; LOAD A CARRIAGE RETURN INTO BUFF
         LHLD   NBUF  ; GET NEXT BUFF ADDRESS   
         MOV    M,A   ; ENTER THE "CR"  
         INX    H   
         XRA    A     ; ZERO
         MOV    M,A   ; LAST BYTE = 0   
         CALL   CRLF
         RET
;   
;-------------------------------------------------------------* 
BUFF:   DW 00000H   
NBUF:   DW 00000H   
KCNT:   DB 000H 
IBUF:   DS 80       ; INPUT DATA BUFFER 
;   
;........................................................*  
ENDIT:   END
